CGERFS(3f)

NAME
CGERFS - the computed solution to a system of linear equations and provides error bounds and backward error estimates for the solution

SYNOPSIS

SUBROUTINE CGERFS(
    TRANS, N, NRHS, A, LDA, AF, LDAF, IPIV, B, LDB, X, LDX, FERR, BERR, WORK, RWORK, INFO )

CHARACTER
    TRANS

INTEGER
    INFO, LDA, LDAF, LDB, LDX, N, NRHS

INTEGER
    IPIV( * )

REAL
    BERR( * ), FERR( * ), RWORK( * )

COMPLEX
    A( LDA, * ), AF( LDAF, * ), B( LDB, * ), WORK( * ), X( LDX, * )

PURPOSE
CGERFS improves the computed solution to a system of linear equations and provides error bounds and backward error estimates for the solution.

ARGUMENTS

TRANS   (input) CHARACTER*1
    Specifies the form of the system of equations:
    = 'N': A * X = B (No transpose)
    = 'T': A**T * X = B (Transpose)
    = 'C': A**H * X = B (Conjugate transpose)

N       (input) INTEGER
    The order of the matrix A. N >= 0.

NRHS    (input) INTEGER
    The number of right hand sides, i.e., the number of columns of the matrices B and X. NRHS >= 0.

A       (input) COMPLEX array, dimension (LDA,N)
    The original N-by-N matrix A.

LDA     (input) INTEGER
    The leading dimension of the array A. LDA >= max(1,N).

AF      (input) COMPLEX array, dimension (LDAF,N)
    The factors L and U from the factorization A = P*L*U as computed by CGETRF.

LDAF    (input) INTEGER
    The leading dimension of the array AF. LDAF >= max(1,N).

IPIV    (input) INTEGER array, dimension (N)
    The pivot indices from CGETRF; for 1<=i<=N, row i of the matrix was interchanged with row IPIV(i).

B       (input) COMPLEX array, dimension (LDB,NRHS)
    The right hand side matrix B.

LDB     (input) INTEGER
    The leading dimension of the array B. LDB >= max(1,N).

X       (input/output) COMPLEX array, dimension (LDX,NRHS)
    On entry, the solution matrix X, as computed by CGETRS. On exit, the improved solution matrix X.

LDX     (input) INTEGER
    The leading dimension of the array X. LDX >= max(1,N).

FERR    (output) REAL array, dimension (NRHS)
    The estimated forward error bound for each solution vector X(j) (the j-th column of the solution matrix X). If XTRUE is the true solution corresponding to X(j), FERR(j) is an estimated upper bound for the magnitude of the largest element in (X(j) - XTRUE) divided by the magnitude of the largest element in X(j). The estimate is as reliable as the estimate for RCOND, and is almost always a slight overestimate of the true error.

BERR    (output) REAL array, dimension (NRHS)
    The componentwise relative backward error of each solution vector X(j) (i.e., the smallest relative change in any element of A or B that makes X(j) an exact solution).

WORK    (workspace) COMPLEX array, dimension (2*N)

RWORK   (workspace) REAL array, dimension (N)

INFO    (output) INTEGER
    = 0: successful exit
    < 0: if INFO = -i, the i-th argument had an illegal value

PARAMETERS
ITMAX is the maximum number of steps of iterative refinement.